#include <sdl2/SDL.h>
//#include <sdl2/SDL_image.h>
#include <iostream>

int Filtro1(void *datos, SDL_Event *evento) {
    if(evento->type == SDL_MOUSEBUTTONUP) {
        std::cout << "mouse button up" << std::endl;
        return 0;
    }
    return 1;
}

int Filtro2(void *datos, SDL_Event *evento) {
    if(evento->type == SDL_MOUSEBUTTONDOWN)
        std::cout << "mouse button down" << std::endl;
    return 0;
}

int main( int argc, char * argv[] ) {
    SDL_Window *ventana;
    SDL_Event evento;
    SDL_Event evento2;
    bool salir=false;
    Uint32 tipoUser;
    Uint32 tipoEscape;

    SDL_Init(SDL_INIT_EVERYTHING);
    ventana = SDL_CreateWindow("Eventos",
        SDL_WINDOWPOS_CENTERED, SDL_WINDOWPOS_CENTERED,
            640, 480, SDL_WINDOW_SHOWN);

    // Registramos dos tipos de eventos de usuario
    tipoUser = SDL_RegisterEvents(1);
    tipoEscape = SDL_RegisterEvents(1);
    /* Equivale a:
    tipoUser = SDL_RegisterEvents(2);
    tipoEscape = tipoUser+1;
    // El primer evento registrado vale 0x8000, y los siguientes
    // tienen valores consecutivos.
    */
    SDL_SetEventFilter(Filtro1, NULL);
    SDL_AddEventWatch(Filtro2, NULL);
    do {
        while (SDL_PollEvent(&evento)) {
            if(evento.type == tipoUser) {
                std::cout << "Evento de usuario tecla w" << std::endl;
            }
            if(evento.type == tipoEscape) {
                std::cout << "Evento de usuario tecla escape" << std::endl;
                salir = true;
            }
            switch (evento.type) {
            case SDL_MOUSEBUTTONDOWN:
                std::cout << "Boton pulsado" << std::endl;
                break;
            case SDL_MOUSEBUTTONUP:
                // Evento filtrado, nunca se activa esta opcin
                std::cout << "Boton soltado (filtrado)" << std::endl;
                break;
            case SDL_MOUSEMOTION:
                std::cout << "Mouse movimiento" << std::endl;
                break;
            case SDL_MOUSEWHEEL:
                std::cout << "Rueda raton" << std::endl;
                break;
            case SDL_QUIT:
                salir = true;
                break;
            case SDL_KEYDOWN:
                std::cout << "Tecla pulsada" << std::endl;
                if(evento.key.keysym.scancode==SDL_SCANCODE_W) {
                    SDL_zero(evento2);
                    evento2.type = tipoUser;
                    evento2.user.timestamp = SDL_GetTicks();
                    evento2.user.windowID = 0;
                    evento2.user.code = 0;
                    evento2.user.data1 = 0;
                    evento2.user.data2 = 0;
                    SDL_PushEvent(&evento2);
                }
                if(evento.key.keysym.scancode==SDL_SCANCODE_ESCAPE) {
                    SDL_zero(evento2);
                    evento2.type = tipoEscape;
                    evento2.user.timestamp = SDL_GetTicks();
                    evento2.user.windowID = 0;
                    evento2.user.code = 0;
                    evento2.user.data1 = 0;
                    evento2.user.data2 = 0;
                    SDL_PushEvent(&evento2);
                }
            case SDL_KEYUP:
            case SDL_TEXTINPUT:
                break;
            default:
                std::cout << evento.type << std::endl;
                break; // Ignorar los que no nos interesen,
            }
        }
    } while(!salir);

    SDL_DestroyWindow(ventana);
    SDL_Quit();
    return 0;
}
